#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

#include "cpu.h"
#include "types.h"
#include "config.h"
#include "allegro.h"
#include "vmachine.h"

//#define SAMPLE_RATE	23598
#define SAMPLE_RATE 20000
#define SHIFT_F1 3933
#define SHIFT_F0 983

AUDIOSTREAM *stream;

FILE *sndlg;

#define SOUND_BUF 1152
#define AUD_CTRL  0xAA
#define AUD_D0	  0xA7
#define AUD_D1	  0xA8
#define AUD_D2	  0xA9

int sound_IRQ;

void audio_process (register unsigned char *buffer, register unsigned int n)
{
	unsigned long aud_data, temp_data;
	int pnt,cnt1,cnt2;
	int cnt_rate;
	int volume,re_circ,i;	
	
	re_circ = VDCwrite[AUD_CTRL] & 0x40;
	volume = VDCwrite[AUD_CTRL] & 0x0F;
	if (VDCwrite[AUD_CTRL] & 0x20) 
		cnt_rate = SAMPLE_RATE/SHIFT_F1;
	else
		cnt_rate = SAMPLE_RATE/SHIFT_F0;
		
	if (VDCwrite[AUD_CTRL] & 0x80) {
//		aud_data = VDCwrite[AUD_D0];
//		aud_data |= (VDCwrite[AUD_D1] << 8);
//		aud_data |= (VDCwrite[AUD_D2] << 16);
		aud_data = VDCwrite[AUD_D2];
		aud_data |= (VDCwrite[AUD_D1] << 8);
		aud_data |= (VDCwrite[AUD_D0] << 16);

		pnt=cnt1=cnt2=0;
		temp_data=aud_data;
		while (pnt < SOUND_BUF) {
			buffer[pnt++] = (temp_data & 0x01) * (0x10 * volume);
			cnt1++;
			if (cnt1 > cnt_rate) {
				cnt1=0;				
				if (!re_circ) {
					temp_data = temp_data >> 1;
				}
				else {
					i = temp_data & 0x01;
					temp_data = temp_data >> 1;
					temp_data = temp_data | (i << 23);	
				}
				if (VDCwrite[0xA0] & 0x04 && !sound_IRQ) {
					sound_IRQ = 1;
					ext_IRQ();
				}		
			}
		}					
	}
	else {
		for (i=0; i<SOUND_BUF; i++) buffer[i]=0;
	}
}

void update_audio() {
	if (app_data.sound_en) {
		unsigned char *p = get_audio_stream_buffer(stream);
				
		if (p) {
			audio_process(p,SOUND_BUF);
//			fwrite(p,1,SOUND_BUF,sndlg);
			free_audio_stream_buffer(stream);
		}
   	}
}


void init_audio() {
	int i;

//	sndlg=fopen("sound.raw","wb");
	
	sound_IRQ=0;		
    if (app_data.sound_en) {
       //i_love_bill=TRUE;
       install_timer();
        printf("Initializing sound system...\n");
        i=install_sound(DIGI_AUTODETECT,MIDI_NONE,0);
        if (i != 0) {
           printf("  ERROR: could not initialize sound card\n   %s\n",allegro_error);
           printf("  Sound system disabled\n");
           app_data.sound_en=0;
        }
        else {
           printf("  Sound system initialized ok\n");
           printf("  Sound driver %s detected\n",digi_driver->name);
           set_volume(200,200);
		   stream = play_audio_stream(SOUND_BUF,8,1,SAMPLE_RATE,255,128);
		   if (!stream) {
		   	  printf("Error creating audio stream!\n");
		   	  app_data.sound_en=0;
		   }  
        }
    }
}

void close_audio() {
	if (app_data.sound_en) {
		stop_audio_stream(stream);
	}
//	fclose(sndlg);
}
