#ifndef CPU_H
#define CPU_H

#include "types.h"

extern BYTE acc;		/* Accumulator */
extern ADDRESS pc;     /* Program counter */
extern long clk;		/* clock */

extern BYTE timer;		/* Internal timer */
extern BYTE reg_pnt;	/* pointer to register bank */
extern BYTE timer_on;  /* 0=timer off/1=timer on */
extern BYTE count_on;  /* 0=count off/1=count on */

extern BYTE t_flag;    /* Timer flag */

extern BYTE psw;		/* Processor status word */
extern BYTE sp;		/* Stack pointer (part of psw) */
extern BYTE bs; 		/* Register Bank (part of psw) */
extern BYTE f0;		/* Flag Bit (part of psw) */
extern BYTE ac;		/* Aux Carry (part of psw) */
extern BYTE cy;	    /* Carry flag (part of psw) */

extern BYTE p1;		/* I/O port 1 */
extern BYTE p2;    /* I/O port 2 */
extern BYTE t0; 		/* Test input 0 */
extern BYTE t1;		/* Test input 1 */


extern void init_cpu(void);
extern void exec(void);
extern void ext_IRQ();
extern void make_psw(void);
extern void tim_IRQ();


extern struct lookup_tag {
	char          *mnemonic;	/* Selfdocumenting? */
        unsigned char  bytes;
        unsigned char  type;
}       lookup[];

#endif  /* CPU_H */








