#include <stdio.h>
#include <string.h>
//#include <conio.h>
#include "cpu.h"
#include "keyboard.h"
#include "vmachine.h"
#include "vdc.h"
#include "allegro.h"

extern int frame;
extern  long colortable[];
extern long clip_low;
extern long clip_high;
extern PALLETE colors;
extern PALLETE oldcol;
#define getch() 0
#define kbhit keypressed

int disasm (ADDRESS p);
void show_reg(void);

void debug(void) {
	int done,i,go,j;
	char inp[80];
	char *tok;
	int r,g,b,c;
	ADDRESS ad,run_to;
	char cr[2],ff[2];
	BYTE d,a;

	stick1=stick2=0;
	cr[0]=13;
	cr[1]=0;
	ff[0]=0x0c;
	ff[1]=0;

	done=go=0;

	while (!done) {
		while (go > 0) {
			disasm(pc);
			exec();
			go--;
		}

		printf("> ");
		gets(inp);
		tok=strtok(inp," ");
		if (!strcmp(tok,"h") || !strcmp(tok,"?") || !strcmp(tok,"help")) {
			printf("display - show display\n");
			printf("cls - clear screen\n");
			printf("clrkey - clear keypresses\n");
			printf("setkey n - set key n pressed\n");
			printf("s - step\n");
			printf("reg - display registers\n");
			printf("stack - display stack\n");
			printf("q - quit\n");
			printf("video - display VDC registers\n");
			printf("exram - display external RAM contents\n");
			printf("run # - run to address #\n");
			printf("go # - execute # instructions\n");
			printf("intram - display internal ram\n");
			printf("md # - display memory #\n");
			printf("wvdc a d - write data d to VDC address a\n");
			printf("\n");
		}
		if (!strcmp(tok,"display")) {
			set_gfx_mode(GFX_BEOS_WINDOWED,320,200,0,0);
			set_palette_range(colors,0,256,0);
			clip_low = 0;
			clip_high = 80000;
			draw_display();
			finish_display();
			while(!kbhit()) {};
			getch();
			set_gfx_mode(GFX_TEXT,80,25,0,0);
		}
		if (!strcmp(tok,"cls")) {
			//clrscr();
		}
		if (!strcmp(tok,"clrkey")) {
			for(i=0; i<128; i++) key[i]=0;
		}
		if (!strcmp(tok,"setkey")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%d",&i);
			printf("Key %d set to pressed\n",i);
			key[i]=1;
		}
		if (!strcmp(tok,"stick")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%x",&i);
			printf("Stick set to %d\n",i);
			stick1=stick2=i;
		}
		if (!strcmp(tok,"s")) {
			disasm(pc);
			show_reg();
			exec();
		}
		if (!strcmp(tok,"reg")) {
			show_reg();
		}
		if (!strcmp(tok,"stack")) {
			for(i=8; i<24; i+=2) {
				ad = intRAM[i];
				d = intRAM[i+1];
				ad = ad | ((d & 0x0F) << 8);
				printf("%x: PC=%x PSW=%x",i,ad,d);
				if (i == sp) printf(" <<SP");
				printf("\n");
			}
			printf("\n");
		}
		if (!strcmp(tok,"q")) {
			done=1;
			free(vscreen);
			free(col);
		}
		if (!strcmp(tok,"pvideo")) {
			j=0;
			fprintf(stderr,"%02x:",0);
			for(i=0; i<256; i++) {
				fprintf(stderr,"%02x,",VDCwrite[i]);
				j++;
				if (j == 16) {
					fprintf(stderr,"%s\n",cr);
					fprintf(stderr,"%02x:",i+1);
					j=0;
				}
			}
			fprintf(stderr,"%s\n",cr);
			fprintf(stderr,"%s",ff);
		}

		if (!strcmp(tok,"video")) {
			j=0;
			printf("%02x:",0);
			for(i=0; i<256; i++) {
				printf("%02x",VDCwrite[i]);
				if (j < 15) printf(",");
				j++;
				if (j == 16 && i != 255) {
					printf("\n");
					printf("%02x:",i+1);
					j=0;
				}
			}
			printf("\n");
		}
		if (!strcmp(tok,"keys")) {
			j=0;
			printf("%02x:",0);
			for(i=0; i<128; i++) {
				printf("%02x,",key[i]);
				j++;
				if (j == 16) {
					printf("\n");
					printf("%02x:",i+1);

					j=0;
				}
			}
			printf("\n");
		}

		if (!strcmp(tok,"col")) {
			j=0;
			printf("%02x:",0);
			for(i=0; i<256; i++) {
				printf("%02x,",coltab[i]);
				j++;
				if (j == 16) {
					printf("\n");
					printf("%02x:",i+1);

					j=0;
				}
			}
			printf("\n");
			printf("Colreg: %x\n ",ext_read(0xA2));
		}


		if (!strcmp(tok,"exram")) {
			j=0;
			printf("%02x:",0);
			for(i=0; i<256; i++) {
				printf("%02x",extRAM[i]);
				if (j < 15) printf(",");
				j++;
				if (j == 16 && i !=255) {
					printf("\n");
					printf("%02x:",i+1);

					j=0;
				}
			}
			printf("\n\n");
		}

		if (!strcmp(tok,"intram")) {
			j=0;
			printf("%02x:",0);
			for(i=0; i<64; i++) {
				printf("%02x",intRAM[i]);
				if (j < 15) printf(",");
				j++;
				if (j == 16 && i != 63) {
					printf("\n");
					printf("%02x:",i+1);
					j=0;
				}
			}
			printf("\n\n");
		}

		if (!strcmp(tok,"run")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%x",&run_to);
			printf("Run to %x\n",run_to);
			while (pc != run_to) {
				exec();
				if (kbhit()) break;
			}
			//clrscr();
			disasm(pc);
			show_reg();

			exec();

		}
		if (!strcmp(tok,"runvb")) {
			printf("Run to VBL");
			while (master_clk < 5500) {
				//gotoxy(1,1);
				printf("%x",pc);
				exec();
				if (kbhit()) break;
			}
			//clrscr();
			disasm(pc);
			show_reg();
			exec();
		}

		if (!strcmp(tok,"runnvb")) {
			printf("Run to no VBL");
			while (master_clk > 5500) {
				//gotoxy(1,1);
				printf("%x",pc);
				exec();
				if (kbhit()) break;
			}
			//clrscr();
			disasm(pc);
			show_reg();
			exec();
		}

		if (!strcmp(tok,"wvdc")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%x",&a);
			tok=strtok(NULL," ");
			sscanf(tok,"%x",&d);
			VDCwrite[a] = d;
		}

		if (!strcmp(tok,"go")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%d",&go);
		}

		if (!strcmp(tok,"di")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%x",&ad);
			for(i=0; i<20; i++) {
				ad = ad + disasm(ad);
			}
			printf("\n");
		}

		if (!strcmp(tok,"md")) {
			tok=strtok(NULL," ");
			sscanf(tok,"%x",&ad);

			printf("\n");
		}
	}
}

void show_reg(void) {
	int i;

		make_psw();
		printf("PC: %04x  A: %02x PSW: %02x P1: %02x  P2: %02x",pc,acc,psw,p1,p2);
		printf("  clk: %d  reg:%d  count:%x  f:%x\n",master_clk,reg_pnt,timer,frame);
		for (i=0; i<8; i++) {
			printf("R%d: %02x   R%d': %02x\n",i,intRAM[i],i,intRAM[i+24]);
		}
}

int disasm (ADDRESS p) {
	BYTE op,d;
	ADDRESS adr;

	op=rom[p++];
	printf("%04x: %02x",p-1,op);
	if (lookup[op].bytes == 2) printf(",%02x",rom[p]);
	printf("  %s",lookup[op].mnemonic);
	switch(lookup[op].type) {
		case 0:
			printf("\n");
			break;
		case 1:
			d=rom[p];
			printf(" #%02x\n",d);
			break;
		case 2:
			adr=rom[p];
			adr = adr | ((op & 0xE0) << 3);
			printf(" $%03x\n",adr);
			break;
		case 3:
			printf(" $%02x\n",rom[p]);
			break;
	}
	return lookup[op].bytes;
}
