#include <stdio.h>
#include <string.h>
#include "types.h"

BYTE rom[5120];

extern struct lookup_tag {
	char          *mnemonic;	/* Selfdocumenting? */
        unsigned char  bytes;
        unsigned char  type;
}       lookup[];

int disasm (ADDRESS p) {
	BYTE op,d;
	ADDRESS adr;
	BYTE nb;

	op=rom[p++];
	printf("%04x:",p-1);
	printf("  %s",lookup[op].mnemonic);
	nb = lookup[op].bytes;
	switch(lookup[op].type) {
		case 0:
			printf("\n");
			break;
		case 1:
			d=rom[p];
			printf(" #%02x\n",d);
			break;
		case 2:
			adr=rom[p];
			adr = adr | ((op & 0xE0) << 3);
			printf(" $%03x\n",adr);
			break;
		case 3:
			printf(" $%02x\n",rom[p]);
			break;
	}
	if (op == 0x83 || op == 0x93) printf("\n");
	return nb;
}

void main(int argc, char **argv)
{
	int i,n;
	char file[50];
	char attr[50],val[50];
	char *p;
	FILE *fn;
	ADDRESS pc;

	if (argc > 1) {
		for(i=1; i<argc; i++) {
			if (argv[i][0] != 45) 	{
				strcpy(file,argv[i]);
			}
			else
			{
			}
		}
	}

	/* load image */

	fn=fopen(file,"rb");
	if (!fn) {
		printf("Error loading %s\n",file);
		exit(0);
	}
	fread(&rom[0x400],1,0x800,fn);
	fclose(fn);
	pc=0x400;
	while (pc < 0xC00) {
		n= disasm(pc);
		pc = pc +n;
	}
	exit(0);
}






