#ifndef VMACHINE_H
#define VMACHINE_H

#include "types.h"

#define LINECNT 21

extern BYTE stick1,stick2;
extern int last_line;

extern int master_clk;		/* Master clock */
extern BYTE coltab[256];

extern BYTE rom1[];
extern BYTE rom2[];
extern BYTE rom3[];
extern BYTE rom4[];

extern BYTE intRAM[];
extern BYTE extRAM[];
extern BYTE VDCwrite[256];
extern BYTE *rom;
extern BYTE *vscreen;


extern BYTE read_P2(void);
extern void ext_write(BYTE dat, ADDRESS adr);
extern BYTE ext_read(ADDRESS adr);
extern void handle_clock();
extern BYTE in_bus(void);
void write_p1(BYTE d);
BYTE read_t1(void);
void init_system();
void run();
void init_timer();


extern struct resource {
	int scan;
	int bank;
	int debug;
	int stick1;
	int stick2;
	int limit;
	char path[80];
	int sound_en;
} app_data;


#endif  /* VMACHINE_H */